config/routes.rb
QuestionBank::Application.routes.draw do
  resources :user_groups

  resources :question_groups

  resources :tags

  resources :attempts

  resources :questions

  get '/questions/quiz/new' => 'questions#prepare_quiz', :as => 'prepare_quiz'
  post '/questions/quiz/new'=> 'questions#generate_quiz', :as => 'generate_quiz'
  match '/questions/quiz/tag/:tag/num/:number_of_questions/show' => 'questions#show_quiz', :as => 'show_quiz'

  get '/downloads/new' => 'downloads#new', :as => 'new_download'
  post '/downloads' => 'downloads#create', :as => 'create_download'

  get '/uploads/new' => 'uploads#new', :as => 'new_upload'
  post '/uploads' => 'uploads#create', :as => 'create_upload'
  get '/uploads/attribute/new' => 'uploads#new_attribute', :as => 'new_attribute'
  post '/uploads/attribute/new' => 'uploads#create_attribute', :as => 'create_attribute'

  post '/api/event/new' => 'api#new_event'
  
  root :to => "home#index"
  resources :users, :only => [:index, :show, :edit, :update ]
  match '/auth/:provider/callback' => 'sessions#create'
  match '/signin' => 'sessions#new', :as => :signin
  match '/signout' => 'sessions#destroy', :as => :signout
  match '/auth/failure' => 'sessions#failure'
end

app/models/tag.rb
class Tag < ActiveRecord::Base
	has_and_belongs_to_many :questions
end

app/controllers/tags_controller.rb
class TagsController < ApplicationController
  load_and_authorize_resource
  # GET /tags
  # GET /tags.json
  def index
    @tags = Tag.all

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @tags }
    end
  end

  # GET /tags/1
  # GET /tags/1.json
  def show
    @tag = Tag.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @tag }
    end
  end

  # GET /tags/new
  # GET /tags/new.json
  def new
    @tag = Tag.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @tag }
    end
  end

  # GET /tags/1/edit
  def edit
    @tag = Tag.find(params[:id])
  end

  # POST /tags
  # POST /tags.json
  def create
    @tag = Tag.new(params[:tag])

    respond_to do |format|
      if @tag.save
        format.html { redirect_to @tag, notice: 'Tag was successfully created.' }
        format.json { render json: @tag, status: :created, location: @tag }
      else
        format.html { render action: "new" }
        format.json { render json: @tag.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /tags/1
  # PUT /tags/1.json
  def update
    @tag = Tag.find(params[:id])

    respond_to do |format|
      if @tag.update_attributes(params[:tag])
        format.html { redirect_to @tag, notice: 'Tag was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @tag.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tags/1
  # DELETE /tags/1.json
  def destroy
    @tag = Tag.find(params[:id])
    @tag.destroy

    respond_to do |format|
      format.html { redirect_to tags_url }
      format.json { head :no_content }
    end
  end
end

app/helpers/tags_helper.rb
module TagsHelper
end

app/views/tags/_form.html.haml
= simple_form_for(@tag) do |f|
  = f.error_notification

  .form-inputs
    = f.input :name
    = f.submit 'Save', :class => 'btn btn-primary'

app/views/tags/edit.html.haml
%h3 Edit Tag

= render 'form'

app/views/tags/index.html.haml
%h3 Tags

= link_to 'Create Tag', new_tag_path, :class => 'btn btn-primary'

%br
%br

%table.table.table-striped
  %tr
    %th Name
    %th

  - @tags.each do |tag|
    %tr
      %td= link_to tag.name, tag
      %td
        = link_to 'Destroy', tag, method: :delete, data: { confirm: 'Are you sure?' }, :class => 'btn btn-danger index-action pull-right'
        = link_to 'Edit', edit_tag_path(tag), :class => 'btn btn-primary index-action pull-right'    
%br

app/views/tags/new.html.haml
= link_to 'Back to Tags', tags_path

%h3 Create Tag

= render 'form'

app/views/tags/show.html.haml
%h3= @tag.name

= link_to 'Edit', edit_tag_path(@tag)

%dl